var fileTempUnitTest = './unitTest/testCase.txt';
const fs = require('fs');
const path = require('path');
const env = 'gentest';

module.exports = function(rawInput,expect,comment)
{

    if(process.env.NODE_ENV == env)
    {
        // console.log(rawInput);
        var input = [];
        var data;
        if(typeof rawInput == "object")
        {
            for(var i=0;i<rawInput.length;i++)
            {
                if(typeof rawInput[i] == "object")
                    data = JSON.stringify(rawInput[i]);
                else
                    data = rawInput[i];            
            
                input.push(data);
            }
        }else
            input.push(rawInput);

            // var track = __stack[1].getFunctionName().split('\.');
            
            var testCase = {
                function : getFunName(2),
                input : input,
                expect : expect,
                from : path.relative('', __stack[1].getFileName()),
                comment : comment ? comment : ""
            };

        // console.log(testCase);
        writeFile(fileTempUnitTest,testCase);
    }
}

Object.defineProperty(global, '__stack', {
    get: function() {
            var orig = Error.prepareStackTrace;
            Error.prepareStackTrace = function(_, stack) {
                return stack;
            };
            var err = new Error;
            Error.captureStackTrace(err, arguments.callee);
            var stack = err.stack;
            Error.prepareStackTrace = orig;
            return stack;
        }
    });

function writeFile(fileName,obj){
    fs.appendFile(fileName, JSON.stringify(obj)+"\r\n", function(err) {
      if(err) {
        return console.log(err);
      }
        // console.log("The file was saved!");
    }); 
}

function getFunName(level)
{
    var track;
    if(level)
        track = __stack[level].getFunctionName().split('\.');
    else    
        track = __stack[1].getFunctionName().split('\.');
    return track[track.length-1];
}

// if(process.env.NODE_ENV == env)
// {
//     try {
//         fs.unlinkSync(fileTempUnitTest);
//     } catch (error) {
        
//     }
// }
    

