
const nodeEnv = process.env.NODE_ENV || 'default';

// setup config
const NodeJsonConfig = require('node-json-config');
const conf = new NodeJsonConfig('app.config.json');

let defaultConfObj = conf.get('default');
// console.log('defaultConfObj');
// console.log(defaultConfObj);

let envConfObj = conf.get(nodeEnv);
// console.log('envConfObj');
// console.log(envConfObj);

let currentConfObj = Object.assign(defaultConfObj, envConfObj);

// console.log('currentConfObj');
// console.log(currentConfObj);

conf.put(nodeEnv, currentConfObj);

conf.getOld = conf.get;
conf.get = function(configName) {
    return conf.getOld(nodeEnv + '.' + configName);
};

module.exports = conf;