module.exports = Object.freeze({
    REQUEST: 'Request',
    RESPONSE: 'Response',
    SUCCESS: 'Success',
    ERROR: 'Error',
    FAIL: 'Fail',
    URLKEYWORD : ["filter","offset","orderby","limit","fields"],
    METHOD:{
        GET : 'GET',
        POST : 'POST',
        PUT : 'PUT',
        DELETE : 'DELETE'
    },
    RESPONSECONN:{
        STATS:{
            ETIMEDOUT:'ETIMEDOUT',
            ECONNREFUSED : 'ECONNREFUSED',
            ESOCKETTIMEDOUT : 'ESOCKETTIMEDOUT',
            MISSING : 'Missing'
        },
        MESSAGE:{
            ETIMEDOUT:{
                resultCode : 'null',
                resultDescription : 'Time out'
            },
            ECONNREFUSED:{
                resultCode : 'null',
                resultDescription : 'Reject'
            },
            ESOCKETTIMEDOUT:{
                resultCode : 'null',
                resultDescription : 'Time out'
            },
            EOTHERERROR:{
                resultCode : 'null',
                resultDescription : 'Error'
            },
            ERROR:{
                resultCode : '50000',
                resultDescription : 'System error'
            },
            SUCCESS:{
                resultCode : '20000',
                resultDescription : 'Success'
            },
            EXCEED:{
                resultCode : '40302',
                resultDescription : 'Exceed data allowances'
            },
            DBERROR:{
                resultCode : '50001',
                resultDescription : 'Database error'
            },
            SUCCESSWITHCON:{
                resultCode : '20001',
                resultDescription : 'Success with condition'
            }
        }
    },
    RESPONSERESULT:{
        SUCCESS:{
            resultCode : '20000',
            resultDescription : 'Success'
        },
        MISSING_INVALID:{
            resultCode : '40300',
            resultDescription : 'Missing or invalid parameter'
        },
        DATA_NOT_FOUND:{
            resultCode : '40401',
            resultDescription : 'Data Not Found'
        },
        DATA_EXIST:{
            resultCode : '40301',
            resultDescription : 'Data Exist'
        },
        ERROR:{
            resultCode : '50000',
            resultDescription : 'System error'
        },
        DENIED:{
            resultCode : '40100',
            resultDescription : 'Access Denied'
        },
        UNKNOW:{
            resultCode : '50060',
            resultDescription : 'Unknown URL'
        }
    }
});