var config = require('./config');
var log = require('./log.js');
var helper = require('./helper');


var nodeName = config.get("appName");
var stat = [];


//client and Node
stat.receiveRequest = function (method,cmd){
    writeStats(nodeName+" Receive "+method+" "+cmd+" Request");
};

stat.receiveBadRequest = function (method,cmd){
    writeStats(nodeName+" Receive Bad "+method+" "+cmd+" Request");
};

stat.sendResponse = function (method,cmd,result){
    writeStats(nodeName+" Send "+method+" "+cmd+" Response "+(result?result:"Success"));
};

//node and mongo
stat.sendQuery = function (method,collection){
    writeStats(nodeName+" Send "+helper.findCmdfromMethod(method)+" "+collection+" Request");
};

stat.receiveBadQuery = function (method,collection){
    writeStats(nodeName+" Receive Bad "+helper.findCmdfromMethod(method)+" "+collection+" Response");
};

stat.receiveQuery = function (method,collection){
    writeStats(nodeName+" Receive "+helper.findCmdfromMethod(method)+" "+collection+" Response");
};

//unknow
stat.receiveUnknow = function(){
    writeStats(nodeName+" Receive Unknown Error Request");
};

stat.sendUnknow = function(){
    writeStats(nodeName+" Send Unknown Error Response");
};

function writeStats(string) {
    log.log(string);
    log.stat(string);
}


module.exports = stat;